/*           CONFIGURATION MANAGEMENT OF EDF VERSION                  */
/* MODIF ERFCAM UTILITAI  DATE 07/04/2009   AUTEUR COURTOIS M.COURTOIS */
/* ================================================================== */
/* COPYRIGHT (C) 1991 - 2001  EDF R&D              WWW.CODE-ASTER.ORG */
/*                                                                    */
/* THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR      */
/* MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS     */
/* PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE */
/* LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.                    */
/* THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,    */
/* BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF     */
/* MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU   */
/* GENERAL PUBLIC LICENSE FOR MORE DETAILS.                           */
/*                                                                    */
/* YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE  */
/* ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,    */
/*    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.     */
/* ================================================================== */

#include <math.h>
#include "aster.h"

//<modif>
//<old>
/*
double DEFP(ERFCAM, erfcam, DOUBLE *x)
{
  DOUBLE y;
#ifdef _POSIX
  y = (DOUBLE)erfc(*x);
  return(y);
#else
  extern DOUBLE STDCALL(ERFCFO,erfcfo)(DOUBLE *);
  y = ERFCFO(x);
  return(y);
#endif
}
*/
//</old>
//<new>
#ifdef _WIN32
	DOUBLE erf_local(DOUBLE x);
	DOUBLE erfc_local(DOUBLE x);
#endif
double DEFP(ERFCAM, erfcam, DOUBLE *x)
{
  DOUBLE y;
#ifdef _POSIX
  y = (DOUBLE)erfc(*x);
  return(y);
#else
#ifdef _WIN32
  y = erfc_local(*x);
  return(y);
#else
  extern DOUBLE STDCALL(ERFCFO,erfcfo)(DOUBLE *);
  y = ERFCFO(x);
  return(y);
#endif
#endif
}

DOUBLE erf_local(DOUBLE x){
    if (fabs(x) > 2.2) {
        return 1.0 - erfc_local(x);
    }
    double sum  = x;
    double term = x;
    double xsqr = x*x;
    int j= 1;
    do {
        term *= xsqr/j;
        sum  -= term/(2*j+1);
        ++j;
        term *= xsqr/j;
        sum  += term/(2*j+1);
        ++j;
    } while (fabs(term)/sum > 1.0e-12);
    return 1.128379167095512574 * sum;
}


DOUBLE erfc_local(DOUBLE x){
    if (fabs(x) < 2.2) {
        return 1.0 - erf_local(x);
    }
    if (signbit(x)) {
        return 2.0 - erfc_local(-x);
    }
    double a = 1;
    double b = x; 
    double c = x;
    double d = x * x + 0.5;
    double q1;
    double q2 = b/d; 
    double n  = 1.0;
    double t;
    do {
        t  = a * n + b * x;
        a  = b;
        b  = t;
        t  = c * n + d * x;
        c  = d;
        d  = t;
        n  += 0.5;
        q1 = q2;
        q2 = b/d;
      } while (fabs(q1-q2)/q2 > 1.0e-12);
    return 0.564189583547756287 * exp(-x*x)*q2;
}
//</new>
//</modif>
